using Opensim.Framework.Persistence.interfaces;
using Opensim.Framework.Persistence.mappings;

namespace Opensim.Framework.Persistence
{
    /// <summary>
    /// Exposes access to NHibernate DAO classes.  Motivation for this DAO
    /// framework can be found at http://www.hibernate.org/328.html.
    /// </summary>
    public class NHibernateDaoFactory : IDaoFactory
    {


        public IAgentsDao GetAgentsDao()
        {
            return new AgentsDao();
        }

        public IAssetsDao GetAssetsDao()
        {
            return new AssetsDao();
        }

        public IInventoryfoldersDao GetInventoryfoldersDao()
        {
            return new InventoryfoldersDao();
        }

        public IInventoryitemsDao GetInventoriitemsDao()
        {
            return new InventoryitemsDao();
        }

        public ILandDao GetLandDao()
        {
            return new LandDao();
        }

        public ILandaccesslistDao GetLandaccesslistDao()
        {
            return new LandaccesslistDao();
        }

        public ILogsDao GetLogsDao()
        {
            return new LogsDao();
        }

        public IPrimitemsDao GetPrimitemsDao()
        {
            return new PrimitemsDao();
        }

        public IPrimsDao GetPrimsDao()
        {
            return new PrimsDao();
        }

        public IPrimshapesDao GetPrimshapesDao()
        {
            return new PrimshapesDao();
        }

        public IRegionsDao GetRegionsDao()
        {
            return new RegionsDao();
        }

        public ITerrainDao GetTerrainDao()
        {
            return new TerrainDao();
        }

        public IUserfriendsDao GetUserfriendsDao()
        {
            return new UserfriendsDao();
        }

        public IUsersDao GetUsersDao()
        {
            return new UsersDao();
        }


        //public ICustomerDao GetCustomerDao() {
        //    return new CustomerDao();
        //}

        //public IHistoricalOrderSummaryDao GetHistoricalOrderSummaryDao() {
        //    return new HistoricalOrderSummaryDao();
        //}

        //public IOrderDao GetOrderDao() {
        //    return new OrderDao();
        //}

        //public ISupplierDao GetSupplierDao() {
        //    return new SupplierDao();
        //}

        #region Inline DAO implementations

        /// <summary>
        /// Concrete DAO for accessing instances of <see cref="Customer" /> from DB.
        /// This should be extracted into its own class-file if it needs to extend the
        /// inherited DAO functionality.
        /// </summary>
        public class AgentsDao : AbstractNHibernateDao<Agents, string>, IAgentsDao { }
        public class AssetsDao : AbstractNHibernateDao<Assets, string>, IAssetsDao { }
        public class InventoryfoldersDao : AbstractNHibernateDao<Inventoryfolders, string>, IInventoryfoldersDao { }
        public class InventoryitemsDao : AbstractNHibernateDao<Inventoryitems, string>, IInventoryitemsDao { }
        public class LandDao : AbstractNHibernateDao<Land, string>, ILandDao { }
        public class LandaccesslistDao : AbstractNHibernateDao<Landaccesslist, string>, ILandaccesslistDao { }
        public class LogsDao : AbstractNHibernateDao<Logs, string>, ILogsDao { }
        public class PrimitemsDao : AbstractNHibernateDao<Primitems, string>, IPrimitemsDao { }
        public class PrimsDao : AbstractNHibernateDao<Prims, string>, IPrimsDao { }
        public class PrimshapesDao : AbstractNHibernateDao<Primshapes, string>, IPrimshapesDao { }
        public class RegionsDao : AbstractNHibernateDao<Regions, string>, IRegionsDao { }
        public class TerrainDao : AbstractNHibernateDao<Terrain, string>, ITerrainDao { }
        public class UserfriendsDao : AbstractNHibernateDao<Userfriends, string>, IUserfriendsDao { }

        public class UsersDao : AbstractNHibernateDao<Users, string>, IUsersDao { }

        //public class CustomerDao : AbstractNHibernateDao<Customer, string>, ICustomerDao { }

        //public class SupplierDao : AbstractNHibernateDao<Supplier, long>, ISupplierDao { }

        #endregion
    }
}
