using Opensim.Framework.Persistence.mappings;

namespace Opensim.Framework.Persistence.interfaces
{
    /// <summary>
    /// Provides an interface for retrieving DAO objects
    /// </summary>
    public interface IDaoFactory 
    {

        IAgentsDao GetAgentsDao();
        IAssetsDao GetAssetsDao();
        IInventoryfoldersDao GetInventoryfoldersDao();
        IInventoryitemsDao GetInventoriitemsDao();
        ILandDao GetLandDao();
        ILandaccesslistDao GetLandaccesslistDao();
        ILogsDao GetLogsDao();
        IPrimitemsDao GetPrimitemsDao();
        IPrimsDao GetPrimsDao();
        IPrimshapesDao GetPrimshapesDao();
        IRegionsDao GetRegionsDao();
        ITerrainDao GetTerrainDao();
        IUserfriendsDao GetUserfriendsDao();

        
        IUsersDao GetUsersDao();
        
        //ICustomerDao GetCustomerDao();
        //IHistoricalOrderSummaryDao GetHistoricalOrderSummaryDao();
        //IOrderDao GetOrderDao();
        //ISupplierDao GetSupplierDao();
    }

    // There's no need to declare each of the DAO interfaces in its own file, so just add them inline here.
    // But you're certainly welcome to put each declaration into its own file.
    #region Inline interface declarations

    public interface IAgentsDao : IDao<Agents, string> { }
    public interface IAssetsDao : IDao<Assets, string> { }
    public interface IInventoryfoldersDao : IDao<Inventoryfolders, string> { }
    public interface IInventoryitemsDao : IDao<Inventoryitems, string> { }
    public interface ILandDao : IDao<Land, string> { }
    public interface ILandaccesslistDao : IDao<Landaccesslist, string> { }
    public interface ILogsDao : IDao<Logs, string> { }
    public interface IPrimitemsDao : IDao<Primitems, string> { }
    public interface IPrimsDao : IDao<Prims, string> { }
    public interface IPrimshapesDao : IDao<Primshapes, string> { }
    public interface IRegionsDao : IDao<Regions, string> { }
    public interface ITerrainDao : IDao<Terrain, string> { }
    public interface IUserfriendsDao : IDao<Userfriends, string> { }
    public interface IUsersDao : IDao<Users, string> { }


    //public interface ICustomerDao : IDao<Customer, string> { }
    //public interface ISupplierDao : IDao<Supplier, long> { }

    #endregion
}
