/*
insert license info here
*/
using System;

namespace Opensim.Framework.Persistence.mappings
{
	/// <summary>
	///	Generated by MyGeneration using the NHibernate Object Mapping adapted by Gustavo
	/// </summary>
	[Serializable]
    public class Agents : DomainObject<string>
	{
		#region Private Members
		private bool _isChanged;
		private bool _isDeleted;
		private string _uuid; 
		private string _sessionid; 
		private string _securesessionid; 
		private string _agentip; 
		private int _agentport; 
		private byte _agentonline; 
		private int _logintime; 
		private int _logouttime; 
		private string _currentregion; 
		private long _currenthandle; 
		private string _currentpos; 		
		#endregion
		
		#region Default ( Empty ) Class Constuctor
		/// <summary>
		/// default constructor
		/// </summary>
		public Agents()
		{
			_uuid = null; 
			_sessionid = null; 
			_securesessionid = null; 
			_agentip = null; 
			_agentport = 0; 
			_agentonline = 0; 
			_logintime = 0; 
			_logouttime = 0; 
			_currentregion = null; 
			_currenthandle = 0; 
			_currentpos = null; 
		}
		#endregion // End of Default ( Empty ) Class Constuctor
		
		#region Public Properties
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string Uuid
		{
			get { return _uuid; }
			set	
			{
				if ( value != null)
					if( value.Length > 36)
						throw new ArgumentOutOfRangeException("Invalid value for Uuid", value, value.ToString());
				
				_isChanged |= (_uuid != value); _uuid = value;
			}
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string Sessionid
		{
			get { return _sessionid; }
			set	
			{
				if ( value != null)
					if( value.Length > 36)
						throw new ArgumentOutOfRangeException("Invalid value for Sessionid", value, value.ToString());
				
				_isChanged |= (_sessionid != value); _sessionid = value;
			}
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string SecureSessionid
		{
			get { return _securesessionid; }
			set	
			{
				if ( value != null)
					if( value.Length > 36)
						throw new ArgumentOutOfRangeException("Invalid value for SecureSessionid", value, value.ToString());
				
				_isChanged |= (_securesessionid != value); _securesessionid = value;
			}
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string Agentip
		{
			get { return _agentip; }
			set	
			{
				if ( value != null)
					if( value.Length > 16)
						throw new ArgumentOutOfRangeException("Invalid value for Agentip", value, value.ToString());
				
				_isChanged |= (_agentip != value); _agentip = value;
			}
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual int AgentPort
		{
			get { return _agentport; }
			set { _isChanged |= (_agentport != value); _agentport = value; }
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual byte AgentOnline
		{
			get { return _agentonline; }
			set	
			{
				//if( value.Length > 0)
					//throw new ArgumentOutOfRangeException("Invalid value for AgentOnline", value, value.ToString());
				
				_isChanged |= (_agentonline != value); _agentonline = value;
			}

		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual int LoginTime
		{
			get { return _logintime; }
			set { _isChanged |= (_logintime != value); _logintime = value; }
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual int LogoutTime
		{
			get { return _logouttime; }
			set { _isChanged |= (_logouttime != value); _logouttime = value; }
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string CurrentRegion
		{
			get { return _currentregion; }
			set	
			{
				if ( value != null)
					if( value.Length > 36)
						throw new ArgumentOutOfRangeException("Invalid value for CurrentRegion", value, value.ToString());
				
				_isChanged |= (_currentregion != value); _currentregion = value;
			}
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual long CurrentHandle
		{
			get { return _currenthandle; }
			set { _isChanged |= (_currenthandle != value); _currenthandle = value; }
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string CurrentPos
		{
			get { return _currentpos; }
			set	
			{
				if ( value != null)
					if( value.Length > 64)
						throw new ArgumentOutOfRangeException("Invalid value for CurrentPos", value, value.ToString());
				
				_isChanged |= (_currentpos != value); _currentpos = value;
			}
		}
			
		/// <summary>
		/// Returns whether or not the object has changed it's values.
		/// </summary>
		public virtual bool IsChanged
		{
			get { return _isChanged; }
		}
		
		/// <summary>
		/// Returns whether or not the object has changed it's values.
		/// </summary>
		public virtual bool IsDeleted
		{
			get { return _isDeleted; }
		}
		
		#endregion 
		
		
		#region Public Functions
		
		/// <summary>
		/// mark the item as deleted
		/// </summary>
		public virtual void MarkAsDeleted()
		{
			_isDeleted = true;
			_isChanged = true;
		}
		
		
		#endregion
		
		
		#region Equals And HashCode Overrides
        ///// <summary>
        ///// local implementation of Equals based on unique value members
        ///// </summary>
        //public override bool Equals(object obj)
        //{
        //    if (this == obj) return true;
        //    if ((obj == null) || (obj.GetType() != this.GetType())) return false;
        //    Agents castObj = (Agents)obj;
        //    return (castObj != null) &&
        //        (this._uuid == castObj.Uuid);
        //}
		
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			
			int hash = 57; 
			hash = 27 * hash * _uuid.GetHashCode();
			return hash; 
		}
		#endregion
		
	}
}
