/*
insert license info here
*/
using System;

namespace Opensim.Framework.Persistence.mappings
{
	/// <summary>
	///	Generated by MyGeneration using the NHibernate Object Mapping adapted by Gustavo
	/// </summary>
	[Serializable]
    public class Assets : DomainObject<string>
	{
		#region Private Members
		private bool _isChanged;
		private bool _isDeleted;
		private string _uuid; 
		private string _name; 
		private string _description; 
		private byte _assettype; 
		private byte _invtype; 
		private byte _local; 
		private byte _temporary; 
		private byte[] _data; 		
		#endregion
		
		#region Default ( Empty ) Class Constuctor
		/// <summary>
		/// default constructor
		/// </summary>
		public Assets()
		{
			_uuid = null; 
			_name = null; 
			_description = null; 
			_assettype = 0; 
			_invtype = 0; 
			_local = 0; 
			_temporary = 0;  
			_data = new byte[]{}; 
		}
		#endregion // End of Default ( Empty ) Class Constuctor
		
		#region Public Properties
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string Uuid
		{
			get { return _uuid; }
			set	
			{
				if ( value != null)
					if( value.Length > 36)
						throw new ArgumentOutOfRangeException("Invalid value for Uuid", value, value.ToString());
				
				_isChanged |= (_uuid != value); _uuid = value;
			}
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string Name
		{
			get { return _name; }
			set	
			{
				if ( value != null)
					if( value.Length > 64)
						throw new ArgumentOutOfRangeException("Invalid value for Name", value, value.ToString());
				
				_isChanged |= (_name != value); _name = value;
			}
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string Description
		{
			get { return _description; }
			set	
			{
				if ( value != null)
					if( value.Length > 64)
						throw new ArgumentOutOfRangeException("Invalid value for Description", value, value.ToString());
				
				_isChanged |= (_description != value); _description = value;
			}
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual byte AssetType
		{
			get { return _assettype; }
			set	
			{
				//if( value.Length > 0)
					//throw new ArgumentOutOfRangeException("Invalid value for AssetType", value, value.ToString());
				
				_isChanged |= (_assettype != value); _assettype = value;
			}

		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual byte InvType
		{
			get { return _invtype; }
			set	
			{
				//if( value.Length > 0)
					//throw new ArgumentOutOfRangeException("Invalid value for InvType", value, value.ToString());
				
				_isChanged |= (_invtype != value); _invtype = value;
			}

		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual byte Local
		{
			get { return _local; }
			set	
			{
				//if( value.Length > 0)
					//throw new ArgumentOutOfRangeException("Invalid value for Local", value, value.ToString());
				
				_isChanged |= (_local != value); _local = value;
			}

		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual byte Temporary
		{
			get { return _temporary; }
			set	
			{
				//if( value.Length > 0)
					//throw new ArgumentOutOfRangeException("Invalid value for Temporary", value, value.ToString());
				
				_isChanged |= (_temporary != value); _temporary = value;
			}

		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual byte[] Data
		{
			get { return _data; }
			set { _isChanged |= (_data != value); _data = value; }
		}
			
		/// <summary>
		/// Returns whether or not the object has changed it's values.
		/// </summary>
		public virtual bool IsChanged
		{
			get { return _isChanged; }
		}
		
		/// <summary>
		/// Returns whether or not the object has changed it's values.
		/// </summary>
		public virtual bool IsDeleted
		{
			get { return _isDeleted; }
		}
		
		#endregion 
		
		
		#region Public Functions
		
		/// <summary>
		/// mark the item as deleted
		/// </summary>
		public virtual void MarkAsDeleted()
		{
			_isDeleted = true;
			_isChanged = true;
		}
		
		
		#endregion
		
		
		#region Equals And HashCode Overrides
        ///// <summary>
        ///// local implementation of Equals based on unique value members
        ///// </summary>
        //public override bool Equals( object obj )
        //{
        //    if( this == obj ) return true;
        //    if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
        //    Assets castObj = (Assets)obj; 
        //    return ( castObj != null ) &&
        //        ( this._uuid == castObj.Uuid );
        //}
		
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			
			int hash = 57; 
			hash = 27 * hash * _uuid.GetHashCode();
			return hash; 
		}
		#endregion
		
	}
}
