/*
insert license info here
*/
using System;

namespace Opensim.Framework.Persistence.mappings
{
	/// <summary>
	///	Generated by MyGeneration using the NHibernate Object Mapping adapted by Gustavo
	/// </summary>
	[Serializable]
    public class Inventoryitems : DomainObject<string>
	{
		#region Private Members
		private bool _isChanged;
		private bool _isDeleted;
		private string _inventoryid; 
		private string _assetid; 
		private int? _assettype; 
		private string _parentfolderid; 
		private string _avatarid; 
		private string _inventoryname; 
		private string _inventorydescription; 
		private int _inventorynextpermissions; 
		private int _inventorycurrentpermissions; 
		private int? _invtype; 
		private string _creatorid; 
		private int _inventorybasepermissions; 
		private int _inventoryeveryonepermissions; 		
		#endregion
		
		#region Default ( Empty ) Class Constuctor
		/// <summary>
		/// default constructor
		/// </summary>
		public Inventoryitems()
		{
			_inventoryid = null; 
			_assetid = null; 
			_assettype =  null; 
			_parentfolderid = null; 
			_avatarid = null; 
			_inventoryname = null; 
			_inventorydescription = null; 
			_inventorynextpermissions = 0; 
			_inventorycurrentpermissions = 0; 
			_invtype =  null; 
			_creatorid = null; 
			_inventorybasepermissions = 0; 
			_inventoryeveryonepermissions = 0; 
		}
		#endregion // End of Default ( Empty ) Class Constuctor
		
		#region Public Properties
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string Inventoryid
		{
			get { return _inventoryid; }
			set	
			{
				if ( value != null)
					if( value.Length > 36)
						throw new ArgumentOutOfRangeException("Invalid value for Inventoryid", value, value.ToString());
				
				_isChanged |= (_inventoryid != value); _inventoryid = value;
			}
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string Assetid
		{
			get { return _assetid; }
			set	
			{
				if ( value != null)
					if( value.Length > 36)
						throw new ArgumentOutOfRangeException("Invalid value for Assetid", value, value.ToString());
				
				_isChanged |= (_assetid != value); _assetid = value;
			}
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual int? AssetType
		{
			get { return _assettype; }
			set { _isChanged |= (_assettype != value); _assettype = value; }
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string ParentFolderid
		{
			get { return _parentfolderid; }
			set	
			{
				if ( value != null)
					if( value.Length > 36)
						throw new ArgumentOutOfRangeException("Invalid value for ParentFolderid", value, value.ToString());
				
				_isChanged |= (_parentfolderid != value); _parentfolderid = value;
			}
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string Avatarid
		{
			get { return _avatarid; }
			set	
			{
				if ( value != null)
					if( value.Length > 36)
						throw new ArgumentOutOfRangeException("Invalid value for Avatarid", value, value.ToString());
				
				_isChanged |= (_avatarid != value); _avatarid = value;
			}
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string InventoryName
		{
			get { return _inventoryname; }
			set	
			{
				if ( value != null)
					if( value.Length > 64)
						throw new ArgumentOutOfRangeException("Invalid value for InventoryName", value, value.ToString());
				
				_isChanged |= (_inventoryname != value); _inventoryname = value;
			}
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string InventoryDescription
		{
			get { return _inventorydescription; }
			set	
			{
				if ( value != null)
					if( value.Length > 64)
						throw new ArgumentOutOfRangeException("Invalid value for InventoryDescription", value, value.ToString());
				
				_isChanged |= (_inventorydescription != value); _inventorydescription = value;
			}
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual int InventoryNextPermissions
		{
			get { return _inventorynextpermissions; }
			set { _isChanged |= (_inventorynextpermissions != value); _inventorynextpermissions = value; }
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual int InventoryCurrentPermissions
		{
			get { return _inventorycurrentpermissions; }
			set { _isChanged |= (_inventorycurrentpermissions != value); _inventorycurrentpermissions = value; }
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual int? InvType
		{
			get { return _invtype; }
			set { _isChanged |= (_invtype != value); _invtype = value; }
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string Creatorid
		{
			get { return _creatorid; }
			set	
			{
				if ( value != null)
					if( value.Length > 36)
						throw new ArgumentOutOfRangeException("Invalid value for Creatorid", value, value.ToString());
				
				_isChanged |= (_creatorid != value); _creatorid = value;
			}
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual int InventoryBasePermissions
		{
			get { return _inventorybasepermissions; }
			set { _isChanged |= (_inventorybasepermissions != value); _inventorybasepermissions = value; }
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual int InventoryEveryOnePermissions
		{
			get { return _inventoryeveryonepermissions; }
			set { _isChanged |= (_inventoryeveryonepermissions != value); _inventoryeveryonepermissions = value; }
		}
			
		/// <summary>
		/// Returns whether or not the object has changed it's values.
		/// </summary>
		public virtual bool IsChanged
		{
			get { return _isChanged; }
		}
		
		/// <summary>
		/// Returns whether or not the object has changed it's values.
		/// </summary>
		public virtual bool IsDeleted
		{
			get { return _isDeleted; }
		}
		
		#endregion 
		
		
		#region Public Functions
		
		/// <summary>
		/// mark the item as deleted
		/// </summary>
		public virtual void MarkAsDeleted()
		{
			_isDeleted = true;
			_isChanged = true;
		}
		
		
		#endregion
		
		
		#region Equals And HashCode Overrides
        ///// <summary>
        ///// local implementation of Equals based on unique value members
        ///// </summary>
        //public override bool Equals( object obj )
        //{
        //    if( this == obj ) return true;
        //    if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
        //    Inventoryitems castObj = (Inventoryitems)obj; 
        //    return ( castObj != null ) &&
        //        ( this._inventoryid == castObj.Inventoryid );
        //}
		
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			
			int hash = 57; 
			hash = 27 * hash * _inventoryid.GetHashCode();
			return hash; 
		}
		#endregion
		
	}
}
