/*
insert license info here
*/
using System;

namespace Opensim.Framework.Persistence.mappings
{
	/// <summary>
	///	Generated by MyGeneration using the NHibernate Object Mapping adapted by Gustavo
	/// </summary>
	[Serializable]
    public class Logs : DomainObject<string>
	{
		#region Private Members
		private bool _isChanged;
		private bool _isDeleted;
		private int _logid; 
		private string _target; 
		private string _server; 
		private string _method; 
		private string _arguments; 
		private int? _priority; 
		private string _message; 		
		#endregion
		
		#region Default ( Empty ) Class Constuctor
		/// <summary>
		/// default constructor
		/// </summary>
		public Logs()
		{
			_logid = 0; 
			_target = null; 
			_server = null; 
			_method = null; 
			_arguments = null; 
			_priority =  null; 
			_message = null; 
		}
		#endregion // End of Default ( Empty ) Class Constuctor
		
		#region Public Properties
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual int Logid
		{
			get { return _logid; }
			set { _isChanged |= (_logid != value); _logid = value; }
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string Target
		{
			get { return _target; }
			set	
			{
				if ( value != null)
					if( value.Length > 36)
						throw new ArgumentOutOfRangeException("Invalid value for Target", value, value.ToString());
				
				_isChanged |= (_target != value); _target = value;
			}
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string Server
		{
			get { return _server; }
			set	
			{
				if ( value != null)
					if( value.Length > 64)
						throw new ArgumentOutOfRangeException("Invalid value for Server", value, value.ToString());
				
				_isChanged |= (_server != value); _server = value;
			}
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string Method
		{
			get { return _method; }
			set	
			{
				if ( value != null)
					if( value.Length > 64)
						throw new ArgumentOutOfRangeException("Invalid value for Method", value, value.ToString());
				
				_isChanged |= (_method != value); _method = value;
			}
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string Arguments
		{
			get { return _arguments; }
			set	
			{
				if ( value != null)
					if( value.Length > 255)
						throw new ArgumentOutOfRangeException("Invalid value for Arguments", value, value.ToString());
				
				_isChanged |= (_arguments != value); _arguments = value;
			}
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual int? Priority
		{
			get { return _priority; }
			set { _isChanged |= (_priority != value); _priority = value; }
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string Message
		{
			get { return _message; }
			set	
			{
				if ( value != null)
					if( value.Length > 0)
						throw new ArgumentOutOfRangeException("Invalid value for Message", value, value.ToString());
				
				_isChanged |= (_message != value); _message = value;
			}
		}
			
		/// <summary>
		/// Returns whether or not the object has changed it's values.
		/// </summary>
		public virtual bool IsChanged
		{
			get { return _isChanged; }
		}
		
		/// <summary>
		/// Returns whether or not the object has changed it's values.
		/// </summary>
		public virtual bool IsDeleted
		{
			get { return _isDeleted; }
		}
		
		#endregion 
		
		
		#region Public Functions
		
		/// <summary>
		/// mark the item as deleted
		/// </summary>
		public virtual void MarkAsDeleted()
		{
			_isDeleted = true;
			_isChanged = true;
		}
		
		
		#endregion
		
		
		#region Equals And HashCode Overrides
        ///// <summary>
        ///// local implementation of Equals based on unique value members
        ///// </summary>
        //public override bool Equals( object obj )
        //{
        //    if( this == obj ) return true;
        //    if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
        //    Logs castObj = (Logs)obj; 
        //    return ( castObj != null ) &&
        //        ( this._logid == castObj.Logid );
        //}
		
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			
			int hash = 57; 
			hash = 27 * hash * _logid.GetHashCode();
			return hash; 
		}
		#endregion
		
	}
}
