/*
insert license info here
*/
using System;

namespace Opensim.Framework.Persistence.mappings
{
	/// <summary>
	///	Generated by MyGeneration using the NHibernate Object Mapping adapted by Gustavo
	/// </summary>
	[Serializable]
    public class Terrain : DomainObject<string>
	{
		#region Private Members
		private bool _isChanged;
		private bool _isDeleted;
		private string _regionuuid; 
		private int? _revision; 
		private byte[] _heightfield; 		
		#endregion
		
		#region Default ( Empty ) Class Constuctor
		/// <summary>
		/// default constructor
		/// </summary>
		public Terrain()
		{
			_regionuuid = null; 
			_revision =  null;  
			_heightfield = new byte[]{}; 
		}
		#endregion // End of Default ( Empty ) Class Constuctor
		
		#region Public Properties
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual string Regionuuid
		{
			get { return _regionuuid; }
			set	
			{
				if ( value != null)
					if( value.Length > 255)
						throw new ArgumentOutOfRangeException("Invalid value for Regionuuid", value, value.ToString());
				
				_isChanged |= (_regionuuid != value); _regionuuid = value;
			}
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual int? Revision
		{
			get { return _revision; }
			set { _isChanged |= (_revision != value); _revision = value; }
		}
			
		/// <summary>
		/// 
		/// </summary>		
		public virtual byte[] Heightfield
		{
			get { return _heightfield; }
			set { _isChanged |= (_heightfield != value); _heightfield = value; }
		}
			
		/// <summary>
		/// Returns whether or not the object has changed it's values.
		/// </summary>
		public virtual bool IsChanged
		{
			get { return _isChanged; }
		}
		
		/// <summary>
		/// Returns whether or not the object has changed it's values.
		/// </summary>
		public virtual bool IsDeleted
		{
			get { return _isDeleted; }
		}
		
		#endregion 
		
		
		#region Public Functions
		
		/// <summary>
		/// mark the item as deleted
		/// </summary>
		public virtual void MarkAsDeleted()
		{
			_isDeleted = true;
			_isChanged = true;
		}
		
		
		#endregion
		
		
		#region Equals And HashCode Overrides
        ///// <summary>
        ///// local implementation of Equals based on unique value members
        ///// </summary>
        //public override bool Equals( object obj )
        //{
        //    if( this == obj ) return true;
        //    if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
        //    Terrain castObj = (Terrain)obj; 
        //    return ( castObj != null ) &&
        //        ( this._regionuuid == castObj.Regionuuid );
        //}
		
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			
			int hash = 57; 
			hash = 27 * hash * _regionuuid.GetHashCode();
			return hash; 
		}
		#endregion
		
	}
}
