/*
insert license info here
*/
using System.Collections.Generic;
using System;
using Opensim.Framework.Persistence.interfaces;
using Opensim.Framework.Persistence.Utils;


namespace Opensim.Framework.Persistence.mappings
{
	/// <summary>
	///	Generated by MyGeneration using the NHibernate Object Mapping adapted by Gustavo
	/// </summary>
    [Serializable]
	public class Users : DomainObject<string>//, IHasAssignedId<string>
	{
		#region Private Members
        private bool _isChanged;
        private bool _isDeleted;
        private string _uuid;
        private string _username;
        private string _lastname;
        private string _passwordhash;
        private string _passwordsalt;
        private long _homeregion;
        private float? _homelocationx;
        private float? _homelocationy;
        private float? _homelocationz;
        private float? _homelookatx;
        private float? _homelookaty;
        private float? _homelookatz;
        private long _created;
        private long _lastlogin;
        private string _userinventoryuri;
        private string _userasseturi;
        private int _profilecandomask;
        private int _profilewantdomask;
        private string _profileabouttext;
        private string _profilefirsttext;
        private string _profileimage;
        private string _profilefirstimage;
        private string _webloginkey;
        #endregion
		
		#region Default ( Empty ) Class Constuctor
		/// <summary>
		/// default constructor
		/// </summary>
		public Users()
		{
            _uuid = null;
            _username = null;
            _lastname = null;
            _passwordhash = null;
            _passwordsalt = null;
            _homeregion = 0;
            _homelocationx = null;
            _homelocationy = null;
            _homelocationz = null;
            _homelookatx = null;
            _homelookaty = null;
            _homelookatz = null;
            _created = 0;
            _lastlogin = 0;
            _userinventoryuri = null;
            _userasseturi = null;
            _profilecandomask = 0;
            _profilewantdomask = 0;
            _profileabouttext = null;
            _profilefirsttext = null;
            _profileimage = null;
            _profilefirstimage = null;
            _webloginkey = null;
        }
		#endregion // End of Default ( Empty ) Class Constuctor
		
		#region Public Properties

        /// <summary>
        /// 
        /// </summary>		
        public virtual string Uuid
        {
            get { return _uuid; }
            set
            {
                if (value != null)
                    if (value.Length > 36)
                        throw new ArgumentOutOfRangeException("Invalid value for Uuid", value, value.ToString());

                _isChanged |= (_uuid != value); _uuid = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual string Username
        {
            get { return _username; }
            set
            {
                if (value != null)
                    if (value.Length > 32)
                        throw new ArgumentOutOfRangeException("Invalid value for Username", value, value.ToString());

                _isChanged |= (_username != value); _username = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual string Lastname
        {
            get { return _lastname; }
            set
            {
                if (value != null)
                    if (value.Length > 32)
                        throw new ArgumentOutOfRangeException("Invalid value for Lastname", value, value.ToString());

                _isChanged |= (_lastname != value); _lastname = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual string PasswordHash
        {
            get { return _passwordhash; }
            set
            {
                if (value != null)
                    if (value.Length > 32)
                        throw new ArgumentOutOfRangeException("Invalid value for PasswordHash", value, value.ToString());

                _isChanged |= (_passwordhash != value); _passwordhash = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual string PasswordSalt
        {
            get { return _passwordsalt; }
            set
            {
                if (value != null)
                    if (value.Length > 32)
                        throw new ArgumentOutOfRangeException("Invalid value for PasswordSalt", value, value.ToString());

                _isChanged |= (_passwordsalt != value); _passwordsalt = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual long HomeRegion
        {
            get { return _homeregion; }
            set { _isChanged |= (_homeregion != value); _homeregion = value; }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual float? HomeLocationx
        {
            get { return _homelocationx; }
            set { _isChanged |= (_homelocationx != value); _homelocationx = value; }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual float? HomeLocationy
        {
            get { return _homelocationy; }
            set { _isChanged |= (_homelocationy != value); _homelocationy = value; }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual float? HomeLocationz
        {
            get { return _homelocationz; }
            set { _isChanged |= (_homelocationz != value); _homelocationz = value; }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual float? HomeLookAtx
        {
            get { return _homelookatx; }
            set { _isChanged |= (_homelookatx != value); _homelookatx = value; }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual float? HomeLookAty
        {
            get { return _homelookaty; }
            set { _isChanged |= (_homelookaty != value); _homelookaty = value; }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual float? HomeLookAtz
        {
            get { return _homelookatz; }
            set { _isChanged |= (_homelookatz != value); _homelookatz = value; }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual long Created
        {
            get { return _created; }
            set { _isChanged |= (_created != value); _created = value; }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual long LastLogin
        {
            get { return _lastlogin; }
            set { _isChanged |= (_lastlogin != value); _lastlogin = value; }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual string UserInventoryuri
        {
            get { return _userinventoryuri; }
            set
            {
                if (value != null)
                    if (value.Length > 255)
                        throw new ArgumentOutOfRangeException("Invalid value for UserInventoryuri", value, value.ToString());

                _isChanged |= (_userinventoryuri != value); _userinventoryuri = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual string UserAsseturi
        {
            get { return _userasseturi; }
            set
            {
                if (value != null)
                    if (value.Length > 255)
                        throw new ArgumentOutOfRangeException("Invalid value for UserAsseturi", value, value.ToString());

                _isChanged |= (_userasseturi != value); _userasseturi = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual int ProfileCanDoMask
        {
            get { return _profilecandomask; }
            set { _isChanged |= (_profilecandomask != value); _profilecandomask = value; }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual int ProfileWantDoMask
        {
            get { return _profilewantdomask; }
            set { _isChanged |= (_profilewantdomask != value); _profilewantdomask = value; }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual string ProfileAboutText
        {
            get { return _profileabouttext; }
            set
            {
                if (value != null)
                    if (value.Length > 0)
                        throw new ArgumentOutOfRangeException("Invalid value for ProfileAboutText", value, value.ToString());

                _isChanged |= (_profileabouttext != value); _profileabouttext = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual string ProfileFirstText
        {
            get { return _profilefirsttext; }
            set
            {
                if (value != null)
                    if (value.Length > 0)
                        throw new ArgumentOutOfRangeException("Invalid value for ProfileFirstText", value, value.ToString());

                _isChanged |= (_profilefirsttext != value); _profilefirsttext = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual string ProfileImage
        {
            get { return _profileimage; }
            set
            {
                if (value != null)
                    if (value.Length > 36)
                        throw new ArgumentOutOfRangeException("Invalid value for ProfileImage", value, value.ToString());

                _isChanged |= (_profileimage != value); _profileimage = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual string ProfileFirstImage
        {
            get { return _profilefirstimage; }
            set
            {
                if (value != null)
                    if (value.Length > 36)
                        throw new ArgumentOutOfRangeException("Invalid value for ProfileFirstImage", value, value.ToString());

                _isChanged |= (_profilefirstimage != value); _profilefirstimage = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>		
        public virtual string WebLoginKey
        {
            get { return _webloginkey; }
            set
            {
                if (value != null)
                    if (value.Length > 36)
                        throw new ArgumentOutOfRangeException("Invalid value for WebLoginKey", value, value.ToString());

                _isChanged |= (_webloginkey != value); _webloginkey = value;
            }
        }
			
		/// <summary>
		/// Returns whether or not the object has changed it's values.
		/// </summary>
		public virtual bool IsChanged
		{
			get { return _isChanged; }
		}
		
		/// <summary>
		/// Returns whether or not the object has changed it's values.
		/// </summary>
		public virtual bool IsDeleted
		{
			get { return _isDeleted; }
		}
		
		#endregion 
		
		
		#region Public Functions
		
		/// <summary>
		/// mark the item as deleted
		/// </summary>
		public virtual void MarkAsDeleted()
		{
			_isDeleted = true;
			_isChanged = true;
		}
		
		
		#endregion
		
		
		#region Equals And HashCode Overrides
        ///// <summary>
        ///// local implementation of Equals based on unique value members
        ///// </summary>
        //public override bool Equals( object obj )
        //{
        //    if( this == obj ) return true;
        //    if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
        //    Users castObj = (Users)obj; 
        //    return ( castObj != null ) &&
        //        ( this._uuid == castObj.Uuid );
        //}
		
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			
			int hash = 57; 
			hash = 27 * hash * _uuid.GetHashCode();
			return hash; 
		}
		#endregion
		
	}
}
